/* exactly same as RGammaOriginal.c in FUNCTIONS/RGamma (M Przeworski) plus seed it */
#include <math.h>
#include <stdio.h>
#include <stdlib.h>



double RGamma(double n,double lambda)
{
  double aa;
  double w;
  int i;
  double ran1();

        double x=0.0;
        if(n<1)
        {
                const double E=2.71828182;
                const double b=(n+E)/E;
                double p=0.0;
                one:
                p=b*ran1();
                if(p>1) goto two;
                x=exp(log(p)/n);
                if(x>-log(ran1())) goto one;
                goto three;
                two:
                x=-log((b-p)/n);
                if (((n-1)*log(x))<log(ran1())) goto one;
                three:;
        }
        else if(n==1.0)

        /* exponential random variable, from Ripley, 1987, P230  */
        {
                double a=0.0;
                double u,u0,ustar;
        ten:
                u=ran1();
                u0=u;
        twenty:
                ustar=ran1();
                if(u<ustar) goto thirty;
                u=ran1();
                if(u<ustar) goto twenty;
                a++;
                goto ten;
        thirty:
                return (a+u0)/lambda;
        }
        else
        {
                double static nprev=0.0;
                double static c1=0.0;
                double static c2=0.0;
                double static c3=0.0;
                double static c4=0.0;
                double static c5=0.0;
                double u1;
                double u2;
                if(n!=nprev)
                {
                        c1=n-1.0;
                        aa=1.0/c1;
                        c2=aa*(n-1/(6*n));
                        c3=2*aa;
                        c4=c3+2;
                        if(n>2.5) c5=1/sqrt(n);
                }
                four:
                u1=ran1();
                u2=ran1();
                if(n<=2.5) goto five;
                u1=u2+c5*(1-1.86*u1);
                if ((u1<=0) || (u1>=1)) goto four;
                five:
                w=c2*u2/u1;
                if(c3*u1+w+1.0/w < c4) goto six;
                if(c3*log(u1)-log(w)+w >=1) goto four;
                six:
                x=c1*w;
                nprev=n;
        }

        return x/lambda;}


double ran1()
{
	double drand48();
	return( drand48() );
}



	void seedit( char *flag )
{
	FILE *fopen(), *pfseed;
	unsigned short seedv[3], seedv2[3],  *seed48(), *pseed ;
	int i;

	if( flag[0] == 's' ) {
	 pfseed = fopen("seedms","r");

        if( pfseed == NULL ) {
           seedv[0] = 3579 ; seedv[1] = 27011; seedv[2] = 59243; }
        else {
	  seedv2[0] = 3579; seedv2[1] = 27011; seedv2[2] = 59243; 
          for(i=0;i<3;i++){ if(  fscanf(pfseed," %hd",seedv+i) < 1 )
		 seedv[i] = seedv2[i] ;
	     }
          fclose( pfseed);
          }
          seed48( seedv );   

       printf("\n%d %d %d\n", seedv[0], seedv[1], seedv[2] );    
	}
	else {
	     pfseed = fopen("seedms","w");
        pseed = seed48(seedv);
        fprintf(pfseed,"%d %d %d\n",pseed[0], pseed[1],pseed[2]);     
	}
}



